<?php
// define file to be spell-checked
$file = "badspelling.txt";

// check spelling
// open dictionary link
$dict = pspell_new("en", "british", "", "", PSPELL_FAST);

// open file
$fp = fopen ($file, 'r') or die ("Cannot open file $file");

// read file line by line
while ($line = fgets($fp, 2048)) {
	// clean up trailing whitespace 
	$line = trim($line);

	// decompose line into individual words
	// check spelling of each word
$line = preg_replace('/[0-9]+/', '', $line);
	$words = preg_split('/[^0-9A-Za-z\']+/', $line, -1, PREG_SPLIT_NO_EMPTY);

	foreach ($words as $w) {
		if (!pspell_check($dict, $w)) {
			$errors[] = $w;
		} 
	}
}

// close file
fclose($fp);

// if errors exist
if (sizeof($errors) > 0) {
	// print error list, with suggested alternatives
	echo "The following words were wrongly spelt: ";
	foreach ($errors as $e) {
		$opts = pspell_suggest($dict, $e);
		echo "$e: " . implode(', ', $opts) . "\n\n";
	}
}
?>
