<?php
// include Math_Complex class
include "Math/Complex.php";

// include Math_ComplexOp class
include "Math/ComplexOp.php";

// define two complex numbers
$complex1 = new Math_Complex(3,2);
$complex2 = new Math_Complex(1,4);

// add the complex numbers
// result: "Sum: 4+6i"
$obj = Math_ComplexOp::add($complex1, $complex2);
echo "Sum: " . $obj->toString() . "\n";

// subtract the complex numbers
// result: "Difference: 2-2i"
$obj = Math_ComplexOp::sub($complex1, $complex2);
echo "Difference: " . $obj->toString() . "\n";

// multiply the complex numbers
// result: "Product: -5+14i"
$obj = Math_ComplexOp::mult($complex1, $complex2);
echo "Product: " . $obj->toString() . "\n";

// divide the complex numbers
// result: "Quotient: 0.647058823529 - 0.588235294118i" 
$obj = Math_ComplexOp::div($complex1, $complex2);
echo "Quotient: " . $obj->toString() . "\n";

// invert a complex number
// result: "Inverted value: 0.230769230769 - 0.153846153846i"
$obj = Math_ComplexOp::inverse($complex1);
echo "Inverted value: " . $obj->toString() . "\n";

// conjugate a complex number
// result: "Conjugated value: 3-2i"
$obj = Math_ComplexOp::conjugate($complex1);
echo "Conjugated value: " . $obj->toString() . "\n";

// multiply a complex number and its conjugate
// product is always a real number (imaginary part = 0)
// result: "Multiplied value: 17 + 0i"
$obj = Math_ComplexOp::mult($complex2, Math_ComplexOp::conjugate($complex2));
echo "Multiplied value: " . $obj->toString();
?>
