<?php
// function to recursively traverse nested arrays
// and search for values matching a pattern
function arraySearchRecursive($needle, $haystack, $path="") {
    // check if input is array
    if (!is_array($haystack)) { die ("Second argument is not array!"); }
    
    // declare a variable to hold matches
    global $matches;

    // iterate over array
    foreach($haystack as $key=>$value) {
        
        if (preg_match("/$needle/i", $key)) {
             $matches[] = array($path . "$key/", "KEY: $key");
         }
                 
        if (is_array($value)) {
            // if a nested array
            // recursively search
            // unset the path once the end of the tree is reached
            $path .= "$key/";
            arraySearchRecursive($needle, $value, $path);
            unset($path);
        } else {
            // if not an array
            // check for match
            // save path if match exists
             if (preg_match("/$needle/i", $value)) {
                 $matches[] = array($path . "$key/", "VALUE: $value");
            }
         }
    }

    // return the list of matches to the caller
    return $matches;
}

// define nested array
$data = array (
    "United States" => array (
        "Texas", 
        "Philadelphia", 
        "California" => array (
            "Los Angeles", 
            "San Francisco" => array(
                "Silicon Valley"))));

// search for string "in"
// result: an array of 2 occurrences with path
print_r(arraySearchRecursive("co", $data));
?>
