<?php
// function to compare length of two values
function sortByLength($a, $b) {
    if (is_scalar($a) && is_scalar($b)) { 
        if (strlen($a) == strlen($b)) {
         return 0;
       } else {
         return (strlen($a) > strlen($b)) ? 1 : -1;
       }
   }
}

// function to recursively sort 
// a series of nested arrays
function sortRecursive(&$arr, $sortFunc, $sortFuncParams = null) {
 
    // check if input is array
    if (!is_array($arr)) { die ("Argument is not array!"); }

    // sort the array using the named function
    $sortFunc($arr, $sortFuncParams);

    // check to see if further arrays exist
    // recurse if so
    foreach (array_keys($arr) as $k) {
        if (is_array($arr[$k])) {
            sortRecursive($arr[$k], $sortFunc, $sortFuncParams);
        }
    }
}

// define nested array
$data = array (
    "United States" => array (
        "West Virginia",
        "Texas" => array(
            "Dallas", "Austin"), 
        "Philadelphia", "Vermont", "Kentucky",
        "California" => array (
            "San Francisco", "Los Angeles", "Cupertino", "Mountain View")));

// sort $data recursively using asort()
sortRecursive($data, 'asort');
print_r($data);

// sort $data recursively using custom function()
sortRecursive($data, 'usort', 'sortByLength');
print_r($data);
?>
