<?php
// define base class
class Generic {
	// properties
	protected $cpu;
	protected $mem;

	// constructor
	function __construct()	{
		echo "Initializing system configuration...\n";
	}
	
	// method to set memory specification
	public function setMemory($val) {
		$this->mem = $val;
		echo "Setting memory to $val MB...\n"; 
	}
	
	// method to set processor specification
	public function setCpu($val) {
		$this->cpu = $val;
		echo "Setting processor to \"$val\"...\n"; 
	}
	
	// method to print current configuration
	public function getConfig() {
		echo "Current configuration: $this->cpu CPU, $this->mem MB RAM\n";
	}

	// destructor
	public function __destruct() {
		echo "De-initializing system configuration...\n";
	}
}

// define extended class
class Server extends Generic {
	// define some more properties
	protected $disk;

	// define some more methods
	function __construct() {
		// run parent constructor
		parent::__construct();
	}

	// method to set disk drive specification
	function setDisk($val) {
		$this->disk = $val;
		echo "Setting disk storage to $val GB...\n"; 
	}

	// method to add memory
	function addMemory($val) {
		$this->mem += $val;
		echo "Adding $val MB of memory\n";	
	}
	
	// override parent method to print current configuration
	public function getConfig() {
		echo "Current configuration: " . $this->cpu . " CPU, $this->mem MB RAM, " . $this->disk . " GB disk storage\n";
	}
}

// create an object of the derived class
$webServer = new Server;

// use methods inherited from base class
$webServer->setMemory(2048);
$webServer->setCpu("Intel Pentium IV");
$webServer->setDisk(450);

// use method defined in derived class
$webServer->addMemory(2048);

// display configuration
// result: "Current configuration: Intel Pentium IV CPU, 4096 MB RAM, 450 GB disk storage"
$webServer->getConfig();
?>
