<?php
// define base class
class Dog {
	// define some properties
	public $name;
	public $age;

	// define some methods
	public function __construct() {
		echo "Constructing a Dog.\n";
	}

	public function wagTail() {
		echo "Hmmm...this is a happy Dog.\n";
	}
}

// extend class
class Bloodhound extends Dog {
	// define some extra properties
	public $color;

	// define some extra methods
	public function sniff() {
		echo "This Dog can smell food a mile away\n";
	}

	public function __destruct() {
		echo "Destroying a Dog.\n";
	}
}

// create an instance of the extended class
$myDog = new Bloodhound();
$myDog->name = "Barry";
$myDog->age = 5;
$myDog->color = "black";

// retrieve class name from instance
echo "Class: " . get_class($myDog) . "\n";

// retrieve parent class name from instance
echo "Parent class: " . get_parent_class(get_class($myDog)) . "\n";

// get and print list of class properties
$vars = get_class_vars(get_class($myDog));
echo "Class properties: ";
foreach ($vars as $key => $value) {
	if (!isset($value)) { $value = "<undef>"; }
	echo "$key=$value ";
}
echo "\n";

// get and print list of object methods
$methods = get_class_methods(get_class($myDog));
echo "Class methods: ";
foreach ($methods as $m) {
	echo "$m ";
}
echo "\n";

// get and print list of instance properties
$vars = get_object_vars($myDog);
echo "Instance properties: ";
foreach ($vars as $key => $value) {
	if (!isset($value)) { $value = "<undef>"; }
	echo "$key=$value ";
}
echo "\n";
?>
