<?php
// define class
class XYCoordinate {
    public $data;
    public function __construct($x, $y) {
        $this->data = array($x, $y);
    }
}

// define class
class Renderer {
    // define overloaded method
    public function __call($method, $args) {
        // check for allowed method names
        if ($method == "render") {
            $numArgs = count($args);
            // execute different code
            // depending on number of arguments passed
            if ($numArgs == 1) {
                echo "Rendering a Point...\n";
            } else if ($numArgs == 2) {
                echo "Rendering a Line...\n";
            } else if ($numArgs >= 3) {
                echo "Rendering a Polygon...\n";
            } else {
                die("ERROR: Insufficient data\n");
            }
         } else {
            die ("ERROR: Unknown method '$method'\n");
        }
    }   
}

// create instance
$r = new Renderer();

// call method with one argument
// result: "Rendering a Point..."
$r->render(new XYCoordinate(1,2));

// call same method with two arguments
// result: "Rendering a Line..." 
$r->render(new XYCoordinate(1,2), new XYCoordinate(20,6));

// call same method with three arguments
// result: "Rendering a Polygon..."
$r->render(new XYCoordinate(1,2), new XYCoordinate(20,6), new XYCoordinate(4,4), new XYCoordinate(18,4));
?>
