<?php
// define class
class Dog {
	// define properties
	private $breed;
	private $name;
	private $age;

	// define a method
	// to handle all set() and get() requests
	function __call($method, $args)	{
		// if get()
		// check if the property exists
		// return its value
		if (substr($method, 0, 3) == "get") {
			$property = substr($method, 3);
			foreach ($this as $key => $value) {
				if (strtolower($property) == strtolower($key)) {
					return $value;
				}
			}
		// if set()
		// check if the property exists
		// alter its value
		} else if (substr($method, 0, 3) == "set") {
			$property = substr($method, 3);
			foreach ($this as $key => $value) {
				if (strtolower($property) == strtolower($key)) {
					$this->{$key} = $args[0];
				}
			}
		// for all other calls
		// generate an error
		} else {
			trigger_error ("Could not find method $method", E_USER_ERROR);
		}
	}
}

// create an instance of the class
$doggy = new Dog();

// set some properties
// using methods that do not actually exist
// all these method calls are handled by __call()
$doggy->setName("Ronald");
$doggy->setAge(3);
$doggy->setBreed("sheepdog");

// check if the properties have been set
print_r($doggy);

// this will generate an error
// because it is not a set() or get() call
$doggy->walk();
?>
