<?php
// function to recursively process
// a directory and all its subdirectories
function dirTraverse($dir) {
    // check if argument is a valid directory
    if (!is_dir($dir)) { die("Argument '$dir' is not a directory!"); }

    // declare variable to hold file list
    global $fileList;
    
    // open directory handle
    $dh = opendir($dir) or die ("Cannot open directory '$dir'!");

    // iterate over files in directory
    while (($file = readdir($dh)) !== false)  {
        // filter out "." and ".."
        if ($file != "." && $file != "..") {
            if (is_dir("$dir/$file")) {
                // if this is a subdirectory
                // recursively process it
                dirTraverse("$dir/$file");
            } else    {
                // if this is a file
                // do something with it
                // for example, reverse file name/path and add to array
                $fileList[] = strrev("$dir/$file");
            }
        }
    }

    // return the final list to the caller
    return $fileList;
}

// recursively process a directory
$result = dirTraverse('./test');
print_r($result);
?>
