<pre>
<?php
// function to recursively process
// a directory and all its subdirectories
// and print a hierarchical list
function printTree($dir, $depth=0) {
    // check if argument is a valid directory
    if (!is_dir($dir)) { die("Argument is not a directory!"); }

    // open directory handle
    $dh = opendir($dir) or die ("Cannot open directory");

    // iterate over files in directory
    while (($file = readdir($dh)) !== false)  {
        // filter out "." and ".."
        if ($file != "." && $file != "..") {
            if (is_dir("$dir/$file")) {
                // if this is a subdirectory (branch)
                // print it and go deeper
                echo str_repeat("  ", $depth) . " [$file]\n";
                printTree("$dir/$file", ($depth+1));
            } else     {
                // if this is a file (leaf)
                // print it
                echo str_repeat("  ", $depth) . " $file\n";
            }
        }
    }
}

// recursively process and print directory tree
printTree('./test/');
?>
</pre>
