<?php
// function to recursively copy
// a directory and its subdirectories
function copyRecursive($source, $destination) {
    // check if source exists
    if (!file_exists($source)) { die("'$source' is not valid"); }

    if (!is_dir($destination)) {
        mkdir ($destination);
    }
    
    // open directory handle
    $dh = opendir($source) or die ("Cannot open directory '$source'");

    // iterate over files in directory
    while (($file = readdir($dh)) !== false) {
        // filter out "." and ".."
        if ($file != "." && $file != "..") {
            if (is_dir("$source/$file")) {
                // if this is a subdirectory
                // recursively copy it
                copyRecursive("$source/$file", "$destination/$file");
            } else {
                // if this is a file
                // copy it
                copy ("$source/$file", "$destination/$file") or die ("Cannot copy file '$file'");
            }
        }
    }

    // close directory
    closedir($dh);
}

// copy directory recursively
copyRecursive("www/template", "www/site12");
echo "Directories successfully copied.";
?>
