<?php
// function to recursively delete 
// a directory and its subdirectories
function deleteRecursive($dir) {
    // check if argument is a valid directory
    if (!is_dir($dir)) { die("'$dir' is not a valid directory"); }

    // open directory handle
    $dh = opendir($dir) or die ("Cannot open directory '$dir'");

    // iterate over files in directory
    while (($file = readdir($dh)) !== false)  {
        // filter out "." and ".."
        if ($file != "." && $file != "..") {
            if (is_dir("$dir/$file")) {
                // if this is a subdirectory
                // recursively delete it
                deleteRecursive("$dir/$file");
            } else {
                // if this is a file
                // delete it
                unlink ("$dir/$file") or die ("Cannot delete file '$file'");
            }
        }
    }
    // close directory
    closedir($dh);
    
    // remove top-level directory
    rmdir($dir);
}

// delete directory recursively
deleteRecursive("junk/robert/");
echo "Directories successfully deleted.";
?>
