<?php
// function to recursively search
// directories for matching filenames
function searchRecursive($dir, $pattern) {
    // check if argument is a valid directory
    if (!is_dir($dir)) { die("Argument '$dir' is not a directory!"); }

    // declare array to hold matches
    global $matchList;

    // open directory handle
    $dh = opendir($dir) or die ("Cannot open directory '$dir'!");

    // iterate over files in directory
    while (($file = readdir($dh)) !== false) {
        // filter out "." and ".."
        if ($file != "." && $file != "..") {
            if (is_dir("$dir/$file")) {
            // if this is a subdirectory
                // recursively process it
                searchRecursive("$dir/$file", $pattern);
            } else {
            // if this is a file
                // check for a match
                // add to $matchList if found
                if (preg_match("/$pattern/", $file))    {
                    $matchList[] = "$dir/$file";
                }
            }
        }
    }

    // return the final list to the caller
    return $matchList;
}

// search for file names containing "ini"
$fileList = searchRecursive("c:/windows", "ini");
print_r($fileList);
?>
