<?php
// function to recursively process
// a directory and all its subdirectories
function calcDirUsage($dir) {
    // check if argument is a valid directory
    if (!is_dir($dir)) { die("Argument '$dir' is not a directory!"); }

    // declare variable to hold running total
    global $byteCount;
    
    // open directory handle
    $dh = opendir($dir) or die ("Cannot open directory '$dir'!");

    // iterate over files in directory
    while (($file = readdir($dh)) !== false) {
        // filter out "." and ".."
        if ($file != "." && $file != "..") {
            if (is_dir("$dir/$file")) {
                // if this is a subdirectory
                // recursively process it
                calcDirUsage("$dir/$file");
            } else {   
                // if this is a file
                // add its size to the running total
                $byteCount += filesize("$dir/$file");
            }
        }
    }

    // return the final list to the caller
    return $byteCount;
}

// calculate disk usage for directory in MB
$bytes = calcDirUsage("c:/windows");
$used = round($bytes/1048576);
echo "$used MB used";
?>
