<?php 
// increase script execution time limit
ini_set('max_execution_time', 600);

// include HTML_Progress class
include "HTML/Progress2.php";
 
// include HTTP_Request class
include "HTTP/Request.php";

// set URL of file to be downloaded
$remoteFile = "http://www.some.domain/files/remote.file.zip";

// set name of local copy
$localFile = "downloads/local.file.zip";

// create objects
$progress = new HTML_Progress2();
$request = &new HTTP_Request();

// perform an HTTP request
// get size of file to be downloaded
$request->setUrl($remoteFile);
$request->setMethod("HEAD");
$request->sendRequest(false);
$actualSize = $request->getResponseHeader("Content-Length");
?>
<html>
<head>
<?php 
echo $progress->getStyle(false); 
echo $progress->getScript(false);
?>
</head>
<body>
 
<div id="progress" style="position: absolute; left: 0px">
<?php 
// initialize progress bar display
$progress->display(); 
?>
</div>

<div id="output" style="position: absolute; top: 100px">
<?php
// open the URL
$rfp = fopen($remoteFile, "rb") or die("Cannot open remote file");;

// open local file
$lfp = fopen($localFile, "wb") or die("Cannot open local file");;

// read the remote file in chunks
// calculate percentage left at each stage
// update progress bar in 10% increments
while ($chunk = fread($rfp, 1024)) {
	fwrite($lfp, $chunk) or die("Cannot write to local file");
	$recdSize += strlen($chunk);
	$percent = intval(($recdSize*100)/$actualSize);
	if (($percent % 10 == 0)) {
		$progress->moveStep($percent);
		// flag to improve performance
		// prevent unnecessary calling of display()
	}
}

// close URL pointer
fclose($rfp) or die("Cannot close remote file");

// close file
fclose($lfp) or die("Cannot close local file");

// display success message
echo "File [$remoteFile] successfully copied to [$localFile]";
?>
</div>
</body>
</html>