<?php
// include Cache class
include "Cache.php";

// initialize Cache object
$cache = new Cache('file', array('cache_dir' => 'cache/') );

// generate an ID for this page
$id = $cache->generateID("thisPage");

if ($page = $cache->get($id)) {
   // if the page is already cached
   // get it and print it
   print "\n[CACHED DATA]\n";
   print $page;
} else {
   // if the page is not cached
   // generate and store it in the cache
   $output = "The sum of the numbers 1 to 99000 is: " . array_sum(range(1,99000));
   echo $output;
   $cache->save($id, $output, 60);
}
?>
