<?php
// include Cache class
include "Cache.php";

// initialize Cache object
$cache = new Cache('file', array('cache_dir' => 'cache/') );

// generate an ID for this page
$id = $cache->generateID("myPage");

// see if the page is cached
// if so, get it and print it
// if it is not cached
// generate the page
// and store it in the output buffer
if ($data = $cache->get($id)) {
   print "\n[CACHED DATA]\n";
   print $data;
} else {
	// initialize the output buffer
	ob_start();

	// do whatever is needed
	// to generate the page:
	// - perform SQL queries
	// - parse, read, write files
	// - print HTML header, body, footer
    ?>

    <font size="+1">

    <?php include "header.php"; ?>
    
    <p>This is the page content.<p>
    <p>It can contain <a href="http://www.w3.org/MarkUp/">HTML</a>, client-side code like <u><script language="Javascript">document.writeln("JavaScript");</script></u> and server-side code like <u><?php echo "PHP"; ?></u>.</p>
    
    <p>It can include calculations: <br /><u>
    <?php
	echo "The product of the numbers 1 to 99 is ";
	$product = 1;
	foreach (range(1,99) as $num) {
		$product = $num * $product;
	}
	echo $product;
	?></u></p>
	
	<p>It can include the output of SQL queries: <br /><u>
    <?php
    echo "The MySQL server has been up for ";
    $connection = mysql_connect("localhost", "root", "") or die ("Unable to connect!");
    $result = mysql_query("SHOW STATUS LIKE 'Uptime'") or die ("Error in query: $query. " . mysql_error());
    $row = mysql_fetch_assoc($result);
    echo $row['Value'] . " seconds.";
    mysql_close($connection);
    ?></u>
    
    <p>The current server time is <u><?php echo date("H:i:m", time()); ?></u></p>
    
    <?php include "footer.php"; ?>
    
    </font>

    <?php
	// complete page is now stored in the output buffer
	// save buffer contents to the cache
	// set cached data to expire after 1 minute
	$cache->save($id, ob_get_contents(), 60);
  
  	// dump buffer contents to the client
	ob_end_flush();
}
?>
