<html>
<head></head>
<body>
<?php
// include Pager class
include "Pager/Pager.php";

// define directory path
$dir = '/home/user/downloads';

// check if it is a directory
if (is_dir($dir)) {
	// open directory handle
	$dh = opendir($dir) or die ("Cannot open directory '$dir'!");

	// iterate over files in directory
	while (($file = readdir($dh)) !== false) {
		// optional, filter out "." and ".."
		if ($file != "." && $file != "..") {
			// store the file list anf file size in an array
			$fileList[] = array($file, filesize($dir . "/" . $file));
		}
	}

	// close directory
	closedir($dh);
} else { 
	die("Argument '$dir' is not a directory!"); 
}

// set up the paging engine
// define items per page 
$options = array(
    "itemData" => $fileList,  // data set
    "perPage" => 10,	       // items per page
    "delta" => 8,            // number of page numbers to display
    "mode"  => "Jumping"     // paging mode
);

// initialize object
$pager = &Pager::factory($options);

// get items for this page as array
$items = $pager->getPageData();

// get page numbers and links for this page
$links = $pager->getLinks();

// get total number of pages
$totalPages = $pager->numPages();

// get current page number
$currentPage = $pager->getCurrentPageID();
?>

<p align="center" />

<?php
// header
// print next, previous links 
// print page number links
echo $links['all'];
?>

<p align="left" />

<?php
// print items on this page
// file name and size
foreach ($items as $item) {
	echo $item[0] . " (" . $item[1] . " bytes)<p />";
}
?>

<p align="right" />

<?php
// footer
// print current page number and total pages
echo "Page $currentPage of $totalPages";
?>
</body>
</html>
