<?php
// function to validate an integer
function validateInteger($str) {
    // test if input is an integer, optionally signed
    return preg_match("/^-?([0-9])+$/", $str);
}

// function to validate a float
function validateFloat($str) {
    // test if input is a floating-point number, optionally signed
    return preg_match("/^-?([0-9])+([\.|,]([0-9])*)?$/", $str);
}

// result: "Is an integer"
echo validateInteger("123456") ? "Is an integer" : "Is not an integer";

// result: "Is not an integer"
echo validateInteger("123456.506") ? "Is an integer" : "Is not an integer";

// result: "Is not an integer"
echo validateInteger("12a3456.506") ? "Is an integer" : "Is not an integer";

// result: "Is a float"
echo validateFloat("123456") ? "Is a float" : "Is not a float";

// result: "Is a float"
echo validateFloat("123456.506") ? "Is a float" : "Is not a float";
?>
