<?php
// function to validate an international phone number
function validateIntlPhone($str) {
    // test if input is of the form +cc aa nnnn nnnn 
    return preg_match("/^(\+|00)[1-9]{1,3}(\.|\s|-)?([0-9]{1,5}(\.|\s|-)?){1,3}$/", $str);
}

// result: "Is a properly-formatted phone number"
echo validateIntlPhone("+1 301 111 1111") ? "Is a properly-formatted phone number" : "Is an improperly-formatted phone number";

// result: "Is a properly-formatted phone number"
echo validateIntlPhone("0091-11-2123-7574") ? "Is a properly-formatted phone number" : "Is an improperly-formatted phone number";

// result: "Is a properly-formatted phone number"
echo validateIntlPhone("+612 9555-5555") ? "Is a properly-formatted phone number" : "Is an improperly-formatted phone number";

// result: "Is an improperly-formatted phone number"
echo validateIntlPhone("12346") ? "Is a properly-formatted phone number" : "Is an improperly-formatted phone number";
?>
