<?php
// function to validate a US phone number
function validateUSPhone($str) {
    // test if input is of the form aaa-nnn-nnnn
    return preg_match("/^[2-9]\d{2}-\d{3}-\d{4}$/", $str);
}

// function to validate an Indian phone number
function validateIndiaPhone($str) {
    // test if input is of the form (0aa) nnnn nnnn
    return preg_match("/^\(0\d{2}\)\s?\d{8}$/", $str);
}

// result: "Is a properly-formatted phone number"
echo validateUSPhone("301-111-1111") ? "Is a properly-formatted phone number" : "Is an improperly-formatted phone number";

// result: "Is a properly-formatted phone number"
echo validateIndiaPhone("(022) 22885736") ? "Is a properly-formatted phone number" : "Is an improperly-formatted phone number";
?>
