<?php
// include HTML_QuickForm class
include "HTML/QuickForm.php";

// include HTML_Quickform_Controller class
include "HTML/QuickForm/Controller.php";
include "HTML/QuickForm/Action.php";

// initialize session
// form input is stored here
// during page transitions
session_start();

// custom class for form pages
class checkoutPage extends HTML_QuickForm_Page {
    // override default method
    function buildForm() {
        $this->_formBuilt = true;

        // get page name
        // build appropriate form elements
        switch($this->getAttribute("id")) {
            // first page
            case 'persInfo':

                //--- form elements here ---//
                
                // add header
                $this->addElement("header", null, "Personal Information");
                
                // add input boxes
                $this->addElement("text", "name", "Name:", array("size" => 30));
                $this->addElement("text", "email", "E-mail address:");
                $this->addElement("text", "tel", "Telephone:", array("size" => 10));
        
                // add submit button
                $this->addElement("submit", null, "Go to Page 2");
                
                //--- form validation rules here ---//

                // for example
                $this->applyFilter(array("name", "email", "tel"), "trim");
                $this->addRule("name", "Please enter your name", "required");
                $this->addRule("email", "Please enter a valid e-mail address", "email");
                
                break;

            // second page                
            case 'pymtInfo':

                //--- form elements here ---//

                // add header
                $this->addElement("header", null, "Payment Information");
                
                // add card selection list
                $select = $this->addElement("select", "cctype", "Card type:", array("V" => "Visa", "M" => "MasterCard", "A" => "AmEx"));
                
                // add input box for card name
                $this->addElement("text", "ccname", "Name on credit card:", array("size" => 25));
                
                // add input box for card expiry date
                $this->addElement("text", "ccexp", "Credit card expiration date (MM/YYYY):", array("size" => 7));
                
                // add radio button group
                $radio[] =& HTML_QuickForm::createElement("radio", null, null, "Yes", "Y");
                $radio[] =& HTML_QuickForm::createElement("radio", null, null, "No", "N");
                $this->addGroup($radio, "email_invoice", "Email invoice:");

                // add submit button    
                   $this->addElement("submit", null, "Place Order");

                //--- form validation rules here ---//
                
                // for example
                $this->applyFilter(array("ccname", "ccexp"), "trim");
                $this->addRule("ccname", "Please enter the card holder's name", "required");

                break;

            // add cases for additional pages as needed
        }    
        
        // once page is validated and submitted
        // go to next page
        $this->setDefaultAction("next");
    }
}

// custom class for form action
class checkoutAction extends HTML_QuickForm_Action {
    function perform(&$page, $actionName) {
        // get all the submitted data as an array
        $data = $page->controller->exportValues();

        // process the data
        // for example, save to a database or file
        print_r($data);

        // print success message
        echo "Thank you for your order";
    }
}

// initialize form controller
$formMulti =& new HTML_QuickForm_Controller("orderCheckout");

// add pages to form
// each page appears only after previous
// page has been submitted with valid data
$formMulti->addPage(new checkoutPage("persInfo"));
$formMulti->addPage(new checkoutPage("pymtInfo"));

// add more pages here as needed

// add action for final page
$formMulti->addAction("process", new checkoutAction());

// generate form
$formMulti->run();
?>