<?php
// start session
session_start();

// initialize session shopping cart
if (!isset($_SESSION['cart'])) {
    $_SESSION['cart'] = array();
}

// get product list //

// open database
$handle = sqlite_open("products.db") or die ("ERROR: Unable to open database!");

// generate and execute query
$query = "SELECT productSKU, productName, productUnitCost FROM products";
$result = sqlite_query($handle, $query) or die ("ERROR: Cannot execute $query. " . sqlite_error_string(sqlite_last_error($handle)));

// save product list as array
if (sqlite_num_rows($result) > 0) {
    while($row = sqlite_fetch_object($result)) {
        $sku = $row->productSKU;
        $productInfo[$sku] = array();
        $productInfo[$sku]['name'] = $row->productName;
        $productInfo[$sku]['price'] = $row->productUnitCost;
    }
} else { 
    die ("ERROR: Cannot retrieve product information");
}

// close connection
sqlite_close($handle);


// define cart actions //

if (isset($_POST['action'])) {
    switch($_POST['action']) {
        // when items are added
        case 'add':
            // iterate over POST-ed data
            // get SKU and quantity
            foreach ($_POST['addQty'] as $sku => $quantity) {
                // add item SKU and quantity to cart
                if (isset($quantity) && $quantity > 0) {
                    $_SESSION['cart'][$sku] += $quantity;
                }
            }
            break;
    
        // when cart is updated
        case 'update':
            // iterate over POST-ed data
            // get SKU and quantity
            foreach ($_POST['updateQty'] as $sku => $quantity) {
                // if quantity = 0 
                // remove item from cart
                if ($quantity == 0 && trim($quantity) != "") {
                    unset($_SESSION['cart'][$sku]);
                }
                
                // if quantity > 0
                // set new quantity
                if ($quantity > 0) {
                    $_SESSION['cart'][$sku] = $quantity;
                }
            }
            break;
    
        // when cart is reset
        case 'reset':
            // destroy the cart
            $_SESSION['cart'] = array();
            break;
    }
}
?>
<html>
<head></head>
<body>

<table border="0" width="100%" cellpadding="10">
<tr>
<td valign="top">
    <!-- complete product list -->
    <u>Available Products</u>
    <form action="<?=$_SERVER['PHP_SELF']?>" method="post">
    <ol>
<?php
    // print the product list
    foreach ($productInfo as $sku => $item) {
        echo "<li><b>" . $item['name'] . "</b><br />\n";
        echo "Unit price: " . $item['price'] . "<br />\n";
        echo "Quantity: <input type=text size=4 name=addQty[$sku] />\n";
        echo "</li><p />\n";
    }
?>
    </ol>
    <input type="hidden" name="action" value="add">
    <input type="submit" value="Add To Cart">
    </form>
</td>
<td valign="top">
    <!-- current shopping cart-->
    <u>Selected Products</u>
<?php
if (sizeof($_SESSION['cart']) > 0) {
?>
    <form action="<?=$_SERVER['PHP_SELF']?>" method="post">
    <ol>
<?php
    // print the currently selected items
    $total = 0;
    foreach ($_SESSION['cart'] as $sku => $quantity) {
        echo "<li><b>" . $productInfo[$sku]['name'] . "</b><br />\n";
        echo $quantity . " units @ " . $productInfo[$sku]['price'] . " each<br />\n";
        $subtotal = $quantity * $productInfo[$sku]['price'];
        $total += $subtotal;
        echo "Subtotal: " . number_format($subtotal, 2) . "<br />\n";
        echo "New quantity: <input type=text size=4 name=updateQty[$sku] />\n";
        echo "</li><p />\n";
    }
?>
    </ol>
    <b>TOTAL: <?php echo number_format($total, 2); ?></b>
    <p />
    <input type="hidden" name="action" value="update">
    <input type="submit" value="Update Cart">
    </form>

    <form action="<?=$_SERVER['PHP_SELF']?>" method="post">
    <input type="hidden" name="action" value="reset">
    <input type="submit" value="Reset Cart">
    </form>
<?php
} else {
?>
    <p />
    No products selected.
<?php
}
?>
</td>
</tr>
</table>
</body>
</html>
