<?php
// define data array 
$data = array(
    "10" => "tomatoes",
    "11" => "potatoes",
    "12" => "carrots",
    "13" => "onions",
    "14" => "beans"
);

// attempt a connection
try {
   $pdo = new PDO('mysql:dbname=db1;host=localhost', 'user', 'pass');
} catch (PDOException $e) {
   die("ERROR: Cannot connect: " . $e->getMessage());
}

// create prepared statement
$sql = "INSERT INTO products (id, name) VALUES (?, ?)";
$stmt = $pdo->prepare($sql) or die("ERROR: " . implode(":", $pdo->errorInfo()));

// bind parameters to statement
$stmt->bindParam(1, $id);
$stmt->bindParam(2, $name);

// process data array
// execute prepared statement with different values
// on each iteration
foreach ($data as $id => $name) {
    $stmt->execute() or die("ERROR: " . implode(":", $stmt->errorInfo()));
}

// display message
echo "Record(s) successfully added.";

// close connection
unset($pdo);
?>
