<?php
// create XML data string
$xmlData =<<< END
<?xml version="1.0"?>
<movie>
    <title>The Matrix</title>
    <credits>
        <actor>
            <name>Keanu Reeves</name>
            <character>Neo</character>
        </actor>
        <actor>
            <name>Laurence Fishburne</name>    
            <character>Morpheus</character>
        </actor>
        <actor>
            <name>Carrie-Anne Moss</name>    
            <character>Trinity</character>
        </actor>
        <director>
            <name>Andy Wachowski</name>
        </director>
        <director>
            <name>Larry Wachowski</name>
        </director>
    </credits>
    <year>1999</year>
    <duration units="min">120</duration>
</movie>
END;

// read XML data
$xml = simplexml_load_string($xmlData) or die("ERROR: Cannot create SimpleXML object");

// function to recursively iterate over XML tree
// printing node names and values
function xmlTraverse($node) {
    foreach ($node->children() as $name => $data) {
        if (trim($data) != "") {
            echo "$name: [$data, " . strlen($data) . "]\n";
        }
        xmlTraverse($data);
    }
}

// traverse XML tree
// result: "title: [The Matrix, 10] name: [Keanu Reeves, 12] ..."
xmlTraverse($xml);
?>
