<?php
// initialize DOM object
$xml = new DOMDocument("1.0");

// add root node <recipe>
$root = $xml->createElement("list");
$xml->appendChild($root);

// add element <description> to root
$desc = $xml->createElement("description");
$root->appendChild($desc);

// add <description> content
$desc->appendChild($xml->createTextNode("Sam's Shopping List"));

// add comment
$root->appendChild($xml->createComment("item list follows"));

// add <item> child element
// add quantities as attributes
$items = $xml->createElement("items");
$root->appendChild($items);

$item = $xml->createElement("item");
$items->appendChild($item);
$item->appendChild($xml->createTextNode("eggs"));
$item->setAttribute("units", 3);
unset($item);

$item = $xml->createElement("item");
$items->appendChild($item);
$item->appendChild($xml->createTextNode("salt"));
$item->setAttribute("units", "100 gm");

// add CDATA block
$items->appendChild($xml->createCDATASection("You can't make an omelette without breaking eggs"));

// add PI
$root->appendChild($xml->createProcessingInstruction("xml-dummy-pi", "shop('now')"));

// display final tree as HTML...
$xml->formatOutput = true;
echo "<xmp>" . $xml->saveXML() . "</xmp>";

// ...or write it to a file as XML
$xml->save("list.xml") or die("ERROR: Could not write to file");
?>
