<?php
// open connection
$mysqli = new mysqli("localhost", "user", "pass", "db1");
if (mysqli_connect_errno()) {
    die("ERROR: Cannot connect. " . mysqli_connect_error());
}

// create and execute SELECT query
$sql = "SELECT id, name, price FROM products";
if ($result = $mysqli->query($sql)) {
    // if results exist
    // initialize DOM object
    $xml = new DOMDocument("1.0");
    
    // add root node
    $root = $xml->createElement("resultset");
    $xml->appendChild($root);

    // iterate over result set
    // print <record>s and <field>s
    if ($result->num_rows > 0) {
        while($row = $result->fetch_row()) {
            $record = $xml->createElement("record");
            $root->appendChild($record);
            $fieldCount = 0;
            while ($fieldCount < $mysqli->field_count) {
                $field = $xml->createElement("field");
                $record->appendChild($field);
                $field->appendChild($xml->createTextNode($row[$fieldCount]));
                $fieldCount++;
            }
        }
    } 
    $result->close();
} else {
    die("ERROR: " . $mysqli->error . " (query was $sql)");
}

// close connection
$mysqli->close();

// display XML result set as HTML...
$xml->formatOutput = true;
echo "<xmp>" . $xml->saveXML() . "</xmp>";

// ...or write it to a file as XML
$xml->save("results.xml") or die("ERROR: Could not write to file");
?>
