<?php
// set database name (SQLite)
$db = "webmon.db";

// set notification e-mail address
$email = "user@localhost";

// open database file
$handle = sqlite_open($db) or die ("ERROR: Cannot open database");

// create and execute SELECT query
$sql = "SELECT url, md5 FROM urls";
$result = sqlite_query($handle, $sql) or die ("ERROR: " . sqlite_error_string(sqlite_last_error($handle)) . " (query was $sql)");

// check for records
if (sqlite_num_rows($result) > 0) {
    while(list($url, $oldMD5) = sqlite_fetch_array($result)) {
        // read URL contents
        // generate new checksum and compare with old
        $contents = join ('', file($url));
        $newMD5 = md5($contents);
        if ($oldMD5 != $newMD5)    {
            // send notification e-mail for changes
            mail($email, "URL Change Notification", "The URL \"$url\" has changed since it was last checked.", "From: Web Monitor <null@localhost>") or die ("ERROR: Cannot send mail");

            // update database with new MD5
            $sql = "UPDATE urls SET md5='$newMD5' WHERE url='$url'";
            sqlite_query($handle, $sql) or die ("ERROR: " . sqlite_error_string(sqlite_last_error($handle)) . " (query was $sql)");
        }
    }
} else {
    echo "No records found";
}

// close database file
sqlite_close($handle);
?>
