<?php
// turn off error messages
error_reporting(E_NONE);

// try this code
try {
    // open file
    if (!$fh = fopen("somefile.txt", "r")) { 
        throw new Exception("Could not open file!", 12); 
    }

    // read file contents
    if (!$data = fread($fh, filesize("somefile.txt"))) { 
        throw new Exception("Could not read file!", 9); 
    }
        
    // close file
    fclose($fh);

    // print file contents
    echo $data;

// catch errors if any
} catch (Exception $e) {
    echo "Exception! \n";
    echo "Error message: " . $e->getMessage() . " \n";
    echo "Error code: " . $e->getCode() . " \n";
    echo "File and line: " . $e->getFile() . "(" . $e->getLine() . ") \n";
    echo "Trace: " . $e->getTraceAsString() . " \n";
}
?>
