<?php
// include class
include "Benchmark/Profiler.php";

// initialize profiler
$profiler = new Benchmark_Profiler();

// start profiler
$profiler->start();

// open database file
$profiler->enterSection("Connection");  // section start marker
$handle = sqlite_open("products.db") or die ("ERROR: Cannot open database");
$profiler->leaveSection("Connection");  // section end marker

// create and execute SELECT query
$profiler->enterSection("Query");
$sql = "SELECT id, name FROM products";
$result = sqlite_query($handle, $sql) or die ("ERROR: " . sqlite_error_string(sqlite_last_error($handle)) . " (query was $sql)");

// check for returned rows
// print if available
if (sqlite_num_rows($result) > 0) {
    while($row = sqlite_fetch_array($result)) {
        echo $row[0] . " = " . $row[1] . "\n";
    }
}
$profiler->leaveSection("Query");

// close database file
$profiler->enterSection("Connection");
sqlite_close($handle);
$profiler->leaveSection("Connection");

// stop profiler
$profiler->stop();
$profiler->display();
?>
