<?php
// include class
include "Debug.php";
include "Debug/Renderer/HTML_Table_Config.php";

// create object
$debug = new Debug();
$debug->add("Entering script...");  // set debug message
?>
<html>
<head>
<?php
// generate stylesheet for debug output formatting
$debug->add("Generating CSS...");  // set debug message
$html = Debug_Renderer_HTML_Table_Config::singleton()->getConfig();
print($html['HTML_TABLE_stylesheet']); 
?>
</head>
<body>
<?php
// function to get an arbitrary number of bytes
// from a file
function getBytes($file, $startByte, $endByte) {
    // import debugger object
    global $debug;

    $debug->add("Entering getBytes()...");  // set debug message
    $debug->dump($file, "file");            // dump variable
    $debug->dump($startByte, "start byte"); // dump variable
    $debug->dump($endByte, "end byte");     // dump variable
    
    // check for valid range endpoints
    if ($endByte < $startByte) { die("Ending byte number must be greater than or equal to starting byte number!"); }

    // open the file for reading
    $fp = fopen($file, "rb") or die("Cannot open file");
    
    // seek to starting byte
    // retrieve data by character
    // until ending byte
    fseek ($fp, $startByte, SEEK_SET);
    while (!(ftell($fp) > $endByte)) {
        $debug->add("Entering ftell() loop..."); // set debug message
        $data .= fgetc($fp);
        $debug->dump($data, "data string"); // dump variable
    }
    
    // close the file
    fclose($fp) or die ("Cannot close file");
    
    $debug->dump($data, "getBytes retval"); // dump variable
    $debug->add("Exiting getBytes()...");   // set debug message
    
    // return data to caller
    return $data; 
}

// return first 10 bytes of file
echo getBytes("fortunes.txt", 0, 9);

// display debug information
$debug->add("Exiting script...");
$debug->display();
?>
</body>
</html>
