<?php
// include testing framework
include_once "PHPUnit/Framework.php";

// include class to be tested
include "shoppingList.php";

// test class
class shoppingListTest extends PHPUnit_Framework_TestCase {
    // initialization
    public function setUp() {
        $this->groceries = new shoppingList;
    }

    // deinitialization
 public function tearDown() {
        unset($this->groceries);
    }

    // test the add() method
    public function testAddingItem() {
        $this->groceries->add("milk", 2);
        $actual = $this->groceries->get();
        $expected = array("milk" => 2);
        $this->assertEquals($expected, $actual);
    }

    // test the remove() method with a valid item
    public function testRemovingItem() {
        $this->groceries->add("milk", 2);
        $this->groceries->add("eggs", 6);
        $this->groceries->remove("milk");
        $actual = $this->groceries->get();
        $expected = array("eggs" => 6);
        $this->assertEquals($expected, $actual);
    }

    // test the add() and remove() method in combination
    public function testAddingRemovingItem() {
        $this->groceries->add("milk", 2);
        $this->groceries->add("soap", 3);
        $this->groceries->add("spoons", 24);
        $this->groceries->add("eggs", 7);
        $this->groceries->remove("spoons");
        $actual = $this->groceries->get();
        $expected = array("eggs" => 7, "milk" => 2, "soap" => 3);
        $this->assertEquals($expected, $actual);
    }

    // test the pretty() method
    public function testPretty() {
        $this->groceries->add("milk", 2);
        $this->groceries->add("soap", 3);
        $this->groceries->add("spoons", 24);
        $actual = $this->groceries->pretty();
        $expected = "milk(2) soap(3) spoons(24) ";
        $this->assertEquals($expected, $actual);
    }
    
    // test the remove() method with an invalid item
    public function testException() {
        try {
            $this->groceries->add("milk", 2);
            $this->groceries->add("eggs", 6);
            $this->groceries->remove("sugar");
        } catch (KeyException $expected) {
            return;
        }
        $this->fail("A KeyException was not thrown");
    }
}
?>
